Subject: Re: Possible race with br_del_if()

From: Ryan Harper <[email-masked]>
Date: Thu, 18 Aug 2005 17:23:23 -0500

* Stephen Hemminger <[email-masked]> [2005-08-18 17:11]:
> On Thu, 18 Aug 2005 16:40:36 -0500
> Ryan Harper <[email-masked]> wrote:
> 
> > Hello,
> > 
> > I've encountered several oops when adding and removing interfaces from
> > bridges while using Xen.  Most of the details are available [1]here.
> > The short of it is the following sequence:
> 
> Doesn't the mutex in RTNL work right?  or are you calling
> routines with out asserting it?

unregister_netdevice asserts RTNL, add_del_if() in br_ioctl.c doesn't
seem to do so.  I don't see it down dev_get_by_index() path either.  It
looks like any caller of add_del_if() isn't asserting RTNL.  The two
callers I see are:

br_dev_ioctl() in br_ioctl.c
old_dev_ioctl() in br_ioctl.c

-- 
Ryan Harper
Software Engineer; Linux Technology Center
IBM Corp., Austin, Tx
(512) 838-9253   T/L: 678-9253
[email-masked]